;----------------------------------------------------------------
; Reality Boy, demo 2
;  a simple tester to develop new librarys for 
;  programming the VB, as well as some practice in asm.
;  Pumps data out the serial port
;----------------------------------------------------------------
; Original coded by:
;       (C)1999 David Tucker
;       dbt@dana.ucc.nau.edu
;       http://dana.ucc.nau.edu/~dbt/VBMain.html
;----------------------------------------------------------------
; ToDo:
;    Everything! need to read data in, and display the results
;     add a way for the user to modify the data being sent
;----------------------------------------------------------------

	org.		0x07000000			; Start of rom

;----------------------------------------------------------------
; Program Constants (Char Ram, etc)
;----------------------------------------------------------------
	inc.		"vb_defines.inc"		; Defenition of memory space
	inc.		"vb_func.inc"		; Standard Function's

	lb.		ProgStart			; The start of the real program.

;----------------------------------------------------------------
;  VB init
;----------------------------------------------------------------
	.call		VBReset			; Initialize the VB

	;-- Init Link Port --
	;; Pointer to Hardware Controll Reg
	movhi		0x200, $0, $3		;0x02000000 => $3
	;; Write 0x80 to LPT (data to transmit)
	movea		0xFFE4, $0, $4		;0xFFFFFF80 => $4
	st.b		$4, HCREGR_LPT[$3]	;0xE4 => [0x02000008]
	;; Write 0x80 to LPC (Disable Interupt, Internal Clock)
	movea		0x80, $0, $4		;0x00000080 => $4
	st.b		$4, HCREGR_LPC[$3]	;0x80 => [0x02000000]
	;; Write 0xFF to LPC2 (Disable Interupt, etc...)
	mov		-1, $4			;0xFFFFFFFF => $4
	st.b		$4, HCREGR_LPC2[$3]	;0xFF => [0x02000004]
	

	;Pump data out the link port...
	movea		0x84, $0, $4		;0x00000084 => $4
lb.	loop001
	st.b		$4, HCREGR_LPC[$3]	;0x84 => [0x02000000]
	;wait for end of transmition
	ld.b		HCREGR_LPC[$3], $5
	andi		0x02, $5, $5
	bne		-8
	.jump		loop001			; Loop Indefinently

;----------------------------------------------------------------
; Rom Info...         
;----------------------------------------------------------------

	org.	0x0707FDE0			; Game Title, 20 chrs...
	ds. "DEMO2 By David T.   "
        
	org.	0x0707FDF4			; Reserved
	db.	00, 00, 00, 00, 00
        
	org.	0x0707FDF9			; Manufac Code
	ds. "DB"				; David Bruce, this is my Code =0)
						; Change it to whatever you want.
	org.	0x0707FDFB			; Game Code
	ds. "DEM2"
        
	org.	0x0707FDFF			; Rom Ver
	db.	00

;----------------------------------------------------------------
; Interrupt Handlers...
;----------------------------------------------------------------
	org.	0x0707FE00			; Key Interupt
	reti
	org.	0x0707FE10			; Timer Interupt
	reti
	org.	0x0707FE20			; Expantion Port Interupt?
	reti
	org.	0x0707FE30			; Link Port Interupt
	reti
	org.	0x0707FE40			; Video Refresh Interupt
	reti

;----------------------------------------------------------------
; Exception Handlers, probably not necisary...
;----------------------------------------------------------------
	org.	0x0707FF60			;Floating Point Exception (various)
	reti
	org.	0x0707FF70			;???
	reti
	org.	0x0707FF80			;Divide By Zero
	reti
	org.	0x0707FF90			;Invalid Opcode
	reti
	org.	0x0707FFA0			;Trap Instruction (param 0x0n)
	reti
	org.	0x0707FFB0			;Trap Instruction (param 0x1n)
	reti
	org.	0x0707FFC0			;Address Trap
	reti
	org.	0x0707FFD0			;Non Maskable Interupt/Douplexed Exception
	reti
	org.	0x0707FFE0			;Fatal Exception
	reti
        
;----------------------------------------------------------------
; Reset Vector... 
;----------------------------------------------------------------
	org.	0x0707FFF0			; Reset Vector
	.jump	ProgStart			; Trying jump to start
	nop                           
	nop                           
	nop

